/*
 *	main.c
 *
 *	P/ECE CLiP Library Wire Loader
 *
 *	ExportPieceClipWire - P/ECE CLiP Library 3D Object Exporter (Wire)
 *	o̓t@CǂݍށACLiPp[`̎ړĨvWFNgłB
 *	̃c[P̂ŗp邱Ƃ͖Ǝv܂B
 *	2006/07/28prύX
 *	XML`̃C[t[f[^AC`ɕϊc[Ƃėp邱Ƃɂ܂B
 *
 *	* Thu Jun 29 14:41:47 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 *	* Fri Jul 28 00:16:53 JST 2006 Naoyuki Sawa
 *	- ܂ł́AXML`̃C[t[f[^̓ǂݍ݃eXgsvOłA
 *	  ̕ύXɂAC`ɕϊc[Ƃėp邱Ƃɂ܂B
 *	  P/ECEŁAXML`̃C[t[f[^̂܂܈ƁAȉ̂悤Ȗ肪܂B
 *	  EXMLt@C͑傫āAtbV𑽂B
 *	  EXMLt@CǂݍނɂExpatNKvACRAM𑽂B
 *	  E݂wire_load()̓t@C̓ǂݍ݂ɂΉĂȂ̂ŁA
 *	    pext@CŃAvP[V\邱ƂłȂB
 *	  ȏ̂悤Ȗ_邽߂ɁÁA{c[pXML`̃C[t[f[^
 *	  C`ɃRo[gApext@Cɒڊ܂߂邱Ƃɂ܂B
 *	  c[IȃvOł́Awire_load()ɂXMLt@C̓ǂݍ݂s܂B
 *	  (Ƃ΁A3DIuWFNgr[AȂ)
 *	* Sun Aug 10 21:42:25 JST 2008 Naoyuki Sawa
 *	- tool/ExportPieceClipA<vector>vfŒ菬_łȂ_ŏo͂悤ύXƂɒǏ]A
 *	  mesh_load()wire_load()ɁA_̂܂ܓǂݍނAŒ菬_ɕϊ邩̑Iǉ܂B
 *	  {c[ɂA_̂܂ܓǂݍނ(-f)AŒ菬_ɕϊ邩(-x)̃IvVǉ܂B
 */
#include "app.h"

/*****************************************************************************
 *	
 *****************************************************************************/

static void
out_data(const char* prefix, const char* path, const unsigned char* data, int size)
{
	char fname[_MAX_FNAME];
	int i;

	_splitpath(path, NULL, NULL, fname, NULL);
	strupr(fname);
	printf("const unsigned char %s_%s[] = {", prefix, fname);

	for(i = 0; i < size; i++) {
		if(!(i & 15)) {
			printf("\n");
		}
		printf("0x%02X,", data[i]);
	}

	printf("\n};\n");
}

/*****************************************************************************
 *	
 *****************************************************************************/

static int
get_size(const WIRE* w)
{
	int size = 0;
	//
	const vector* v;
	const WSEG* s;
	//
	int nv;
	int ns;
	//
	int iv;
	int is;

	size += sizeof(WIRE);
	nv = w->nv;
	ns = w->ns;
	w++;

	v = (vector*)w;
	for(iv = 0; iv < nv; iv++) {
		size += sizeof(vector);
		v++;
	}

	s = (WSEG*)v;
	for(is = 0; is < ns; is++) {
		size += sizeof(WSEG);
		s++;
	}

	return size;
}

/*****************************************************************************
 *	
 *****************************************************************************/

int
main(int argc, char* argv[])
{
	WIRE* w;
	const char* path;
	int convert_fixed;

	switch(argc) {
	case 1 + 1:
		path = argv[1];
		convert_fixed = 0/*float*/;
		break;
	case 1 + 2:
		path = argv[2];
		       if(!strcmp(argv[1], "-f")) {
			convert_fixed = 0/*float*/;
		} else if(!strcmp(argv[1], "-x")) {
			convert_fixed = 1/*fixed*/;
		} else {
			DIE();
		}
		break;
	default:
		DIE();
	}
	w = wire_load(path, convert_fixed);
	if(!w) {
		DIE();
	}
	out_data("WIRE", path, (unsigned char*)w, get_size(w));
	free(w);

	return 0;
}

